// App builder locators
export let locators = {
  createNewButton: '[data-test-id=create-new-button]',
  appnew: '[data-test-id="new-app-btn"]',
  appname: '#app-name-input',
  appsave: '#subnav-report .save-btn',
  appmore: 'li.dropdown a.more-btn',
  appdelete: '#delete-appgroup',
  appdelete_new: '[data-test-id="delete-apps-btn"]',
  appdeleteconfirmationtxt: '[data-test-id="delete-confirmation-text"]',
  appdeleteconfirmationbtn: '[data-test-id="delete-confirmation-yes"]',
  addmenu: '#ab-subgroup-add',
  menutitle_last: '.app-menu-section:last .app-menu-title',
  menusections: '.app-menu-section',
  menusections_last: '.app-menu-section:last',
  menusections_delete_last: '.app-section-delete:last',
  dashboard_delete: '.app-section-item-delete',
  dashboard_delete_last: '.app-section-item-delete:last',
  dashboard_in_submenu_last: '.app-menu-section:last .menu-viz-list li:last',
  dashboards_in_submenu: '.menu-viz-list li',
  dashboards_in_last_submenu: '.app-menu-section:last .menu-viz-list li',
  dataconnections: '#dash-viz-tab > form > div:nth-child(1) > div > div',
  datasets: '#dash-viz-tab > form > div:nth-child(2) > div > div',
  dashboard_selection: '.app-dashboard-list',
  launch_app: '#view-appgroup-btn',
  apps_list: "[data-test-id='filter-for-apps-button']",
  select_all_app: '#select-app-all',
  latest_created_app: 'table#report-table tbody tr:nth-of-type(1)',
  app_tabs: 'ul.nav.navbar-nav.navbar-left > li',
  dashboard_title: 'div#dashboard-title',
  first_tab: 'ul.nav.navbar-nav.navbar-left > :first-child',
  tab_dropdown: 'ul.nav.navbar-nav.navbar-left > li > ul a',
  exclude_filter:
    'div.control-container li:nth-child(index) div div.picklist-exclude-wrapper input[class="picklist-exclude"]',
  filter_dropdown: 'div.control-container li:nth-child(index) span.caret',
  filter_values: 'div.control-container li:nth-child(index) div > ul > li',
  second_dash_of_first_tab: 'ul.nav.navbar-nav.navbar-left > li > ul li:nth-child(2) a',
  app_tab: 'ul.nav.navbar-nav.navbar-left > li:nth-child(index)',
};
