const queryActionContainer = '.cloudera-cmdline-actions';
const queryNav = '#directaccess-list';

export let locators = {
  dataPageThreeDotDropDownButton: '[data-test-id="import-toggle"]',
  direct_access: 'a#raw-access',
  samples_connection: 'a[title="samples"]',
  ace_editor: 'div.rawcommand-holder div.ace_editor',
  run_button: '#rawcommand-run',
  output_panel: '#rawcommand-output',
  table_title: '#rawcommand-output-title span.title',
  data_table: '#rawcommand-output .dataTables_wrapper',
  table_header: '#rawcommand-output div.dataTables_scrollHead table.dataTable th',
  table_rows: '#rawcommand-output  div.dataTables_scrollBody tbody > tr',
  limitCheckbox: '#limit-100',
  queryActionContainer,
  downLoadResultAsCsv: '.cloudera-cmdline-secondary-actions button:contains(Download)',
  saveQueryButton: `${queryActionContainer} a:contains(Save Query)`,
  more_option_btn: `${queryActionContainer} button#more-option`,
  createDatasetButton: `${queryActionContainer} a:contains(Save as Dataset)`,
  howManyRowToDownloadInputField: '#rawcommand-number-rows-csv-input',
  queryNavigationTabs: {
    queryHistoryTab: `${queryNav} li a:contains(Query History)`,
    savedQueriesTab: `${queryNav} li a:contains(Saved Queries)`,
    resultTab: `${queryNav} li a:contains(Result)`,
    savedQueriesList: '#sql-bookmarks',
    savedQueryCard: '.search-result',
    queryHistoryEntry: '.search-history-entry a',
  },
};
