// Filter Association locators
export let locators = {
  fa_tab: 'li#dataset-filterassociations-sidebar',
  new_fa: 'a#filterassociation-create',
  create_fa_modal: 'div#create-filterassociation-modal',
  fa_name: 'input#filterassociation-create-name',
  segment: 'div#filterassociation-modal-datasets-segments-container',
  save: '#filterassociation-save',
  fa_table: 'table#filterassociations-table',
  delete_popup: '#delete-filterassociation-yes',
  fa_modal: 'div#create-filterassociation-modal',
  users: {
    user_tab: "a[href='#user-tab']",
    add: '#user-tab div.clearfix a.add-selection',
    remove: '#user-tab div.clearfix a.remove-selection',
    selected_users: '#user-tab .selection-list.selected',
    available_users: '#user-tab .selection-list.not-selected',
    search: '#user-tab .selection-search-input input',
    select_all: '#user-tab div.not-selected',
  },
  groups: {
    available_groups: '#groups-tab .selection-list.not-selected',
    add: '#groups-tab div.clearfix a.add-selection',
    remove: '#groups-tab div.clearfix a.remove-selection',
    selected_groups: '#groups-tab .selection-list.selected',
    search: '#groups-tab .selection-search-input input',
    select_all: '#groups-tab div.not-selected',
  },
  fa_data: {
    name: 'table#filterassociations-table tr:nth-child(index) td:nth-child(1)',
    segments: 'table#filterassociations-table tr:nth-child(index) td:nth-child(2)',
    users: 'table#filterassociations-table tr:nth-child(index) td:nth-child(3)',
    groups: 'table#filterassociations-table tr:nth-child(index) td:nth-child(4)',
    edit: 'table#filterassociations-table tr:nth-child(index) td:nth-child(5) a[class *=edit]',
    delete: 'table#filterassociations-table tr:nth-child(index) td:nth-child(5) a[class *=delete]',
  },
};
