export let locators = {
  // import_toggle: 'div.btn-group > button.btn-sm.dropdown-toggle',
  // import_artifacts: 'div.btn-group > ul.dropdown-menu > li:last-child',
  import_toggle: "[data-test-id='import-toggle']",
  import_artifacts: "[data-test-id='import-artifacts']",
  import_input_file: 'input#id_import_file',
  import_button: 'button#import-viz-dash-button',
  import_confirmation: '#viz-dash-import-confirm',
  app_menu: 'ul.app-menu.app-menu-sortable',
  app_toggle: 'a.more-btn',
  export_file_name: '[data-test-id="export-filename"]',
  export_popup: 'div#export-visuals-modal',
  export_button: '[data-test-id="export-submit"]',
  export_close_button: '[data-test-id="export-close"]',
  visuals_list:
    "div#app-list div.btn-group.viz-display-radio-btns > label > input[value='visuals']",
  dashboard_grid: '#app-grid label.btn.btn-default.btn-sm input[value="dashboards"]',
  grid_item: '[data-test-id="grid-item-link"]',
  ellipsis: '.report-menu-list > li:last-child',
  search: 'input#searchbox',
  linked_visual: 'div.linked-text-wrapper',
  specific_visual: '#app-selected-list ul li.gs-w:nth-child(index)',
  table_header:
    '#app-selected-list ul li.gs-w:nth-child(index) div.table-responsive div.dataTables_scrollHead table thead',
  table_body:
    '#app-selected-list ul li.gs-w:nth-child(index) div.table-responsive div.dataTables_scrollBody table tbody',
  navigate_dashboard: 'a.contextmenu-link.cm-nav-link',
};
