export const CSSselector = {
  data_menu: "[data-test-id='topnav-data']",
  homepage: "[data-test-id='topnav-home']",
  Visual_page: "[data-test-id='topnav-visuals']",
  topnav_sql: "[data-test-id='topnav-sql']",
  sql_tab: '#sql-tab',
  run_sql_button: "[data-test-id='run-sql-button']",
  sql_output: "[data-test-id='sql-output']",
  sql_tables_loading_spinner: "[data-test-id='sql-tab-tables-loading-spinner']",
  sql_tab_cli: "[data-test-id='sql-tab-command-line-interface']",
  loading_bar: "[data-test-id='loading-bar']",
  contextmenu_dropdown: "[data-test-id='contextmenu-dropdown']",
  search: '[data-test-id="searchbox"]',
  dataset_create_DB: '#dashboard-create',
  Dashboard_title: "[data-test-id='dashboard-title']",
  Dashboard_subtitle: "[data-test-id='dashboard-subtitle']",
  Dashboard_filters: '.control-container > .control-list',
  Save: "[data-test-id='app-save-link']",
  home_new_dashboard: "[data-test-id='home-new-dashboard']",
  selecting_visuals: "[data-test-id='dash-settings-panel-new-visual-btn']",
  Adding_sheets: '.dash-sheets-container .more-btn',
  list_sheets: '.dashboard-sheet-handles',
  Sheet2_caret: '.sheet-handle:nth-child(2) .caret',
  view_mode: '.view-link',
  Sheet2_rename: '.sheet-handle:nth-child(2) .sheet-rename',
  Sheet2_delete: '.sheet-handle:nth-child(2) .sheet-delete',
  Sheet_title: '.sheet-title',
  Private_WS: '.side-menu-wrapper .fa-lock',
  Sheet2_move_right: '.sheet-handle:nth-child(2) .sheet-move-right',
  Sheet2_title: '.sheet-handle:nth-child(2) .sheet-title',
  Sheet3_Caret: '.sheet-handle:nth-child(3) .caret',
  Sheet3_title: '.sheet-handle:nth-child(3) .sheet-title',
  Sheet2_move_left: '.sheet-handle:nth-child(3) .sheet-move-left',
  Sheet2: '.sheet-handle:nth-child(2)',
  Sheet_3: '.sheet-handle:nth-child(3)',
  Sheet1_caret: '.sheet-handle .caret',
  Sheet1_delete: '.sheet-handle .sheet-delete',
  View_link: '.view-link-container',
  edit_link: "[data-test-id='report-menu-list-editapp-link']",
  viz_hover: '.gs-w:nth-child(1)',
  visual_title: 'li:nth-child(index) .arc-viz-title-container .arc-viz-title',
  visual_edit_first: "li:nth-child(1) a[class='fa fa-cog viz-show-settings']",
  select_field_1: '#app-shelves .selected-list-wrapper',
  visual_container: "div[class='gridster ready']>ul",
  visual_edit_specific: (index: string | number) =>
    `[data-test-id="app-selected-list"] [data-test-id='visual-list-item']:nth-child(${index}) [data-test-id='viz-show-settings']`,
  visual_title_specific: (index: string | number) =>
    `[data-test-id="app-selected-list"] [data-test-id='visual-list-item']:nth-child(${index}) [data-test-id='arc-viz-title']`,
  visual_subtitle_specific: (index: string | number) => `li:nth-child(${index}) .arc-viz-subtitle`,
  visual_rows: 'li:nth-child(index) table tr',
  bar_visual: '#chart-trellis-bars',
  line_visual: '#chart-trellis-lines',
  scatter_visual: '#chart-scatter',
  bar_line_visual: '#chart-combo',
  kpi_visual: '#chart-kpi',
  radial_visual: '#chart-radial',
  sql_visual: '#chart-rawtable',
  sql_visual_textbox: '.rawsql-textbox',
  measure_field: '#y_shelf',
  color_field: '#color_shelf',
  size_field: '#size_shelf',
  filter_field: '#filters_shelf',
  refresh_visual: "[data-test-id='viz-refresh']",
  save_visual: "[data-test-id='app-save-link']",
  selecting_datasets: "[data-test-id='dash-viz-tab-form-datasets']",
  selecting_dataconnection: "[data-test-id='dash-viz-tab-form-dataconnections']",
  active_side_panel: "li[role='presentation'][class='active']",
  filters_tab: "a[data-target='#dash-filters-tab']",
  filters_tab_selection_item:
    "[data-test-id='dashboard-edit-filters-tab'] [data-test-id='selection-field-item']",
  selecting_filter_field: "[title='field_name']",
  visual1_filter_dropdown: '.control-container',
  visual_filter_dropup: '.control-container .selected-picklist-link',
  selecting_datasets_filter: '#dash-filters-tab > form > div:nth-child(2) > div > select',
  selecting_dataconnection_filter: '#dash-filters-tab > form > div:nth-child(1) > div > select',
  visual2_filter_dropdown: 'ul > .selected-control:nth-child(2) .selected-count-suffix',
  visual2_filter_dropup: ".control-container [class='control-list ui-sortable'] > li:nth-child(2)",
  visual1_row_count:
    "#app-selected-list>ul>li:nth-child(1)  div[class=dataTables_scrollBody] tbody tr[role='row']",
  visual2_row_count:
    "#app-selected-list>ul>li:nth-child(2)  div[class=dataTables_scrollBody] tbody tr[role='row']",
  edit_dashboard: 'div.container-fluid ul#report-menu-list .editapp-link',
  data_tab: "a[href='#viz-fields-tab']",
  settings_tab: "a[data-target='#dash-settings-tab']",
  close_dashboard_setting: '#close-dash-settings',
  border_around_visuals: "[name='BORDERS_AROUND_VISUALS']",
  filters_on_left: "[name='FILTERS_ON_LEFT']",
  display_filters: "[name='DISPLAY_FILTERS']",
  visuals_title: "[data-test-id='visual-list-item'] [data-test-id='arc-viz-title']",
  vizual_fields_tab:
    "[data-test-id='visual-data-panel'] [data-test-id='selection-field-item'][data-test-item='column-name']",
  yAxis_field: "div[class*='edit-mode'] #y_shelf",
  measure_field_element: "div[class*='edit-mode'] #aggregates_shelf",
  dimension_field_element: "div[class*='edit-mode'] #dimensions_shelf",
  color_field_first_element:
    "#app-shelves #color_shelf li[class='dropdown app-shelf-item']:nth-child(1)",
  color_field_second_element:
    "#app-shelves #color_shelf li[class='dropdown app-shelf-item']:nth-child(2)",
  expression_data: "[data-test-id='expression-data']",
  expression_data_input: "[data-test-id='expression-data'] textarea[class='ace_text-input']",
  expression_data_input_ace_line:
    '#expression-data > div.ace_scroller > div > div.ace_layer.ace_text-layer > div > div',
  expression_validate: '#expression-validate',
  expression_save: "[data-test-id='expression-save']",
  property_axis: "#properties-panel li[data-category='axis-functions']",
  secondary_axis: "li[class*='open'][data-category='axis-functions'] li:nth-child(2)",
  close_property_panel: "span[class='fa fa-remove properties-panel-close']",
  visual_settings_tab: "[data-test-id='visual-settings-tab-a']",
  visual_settings_mark: "[data-test-id='visual-style-tab-Marks']",
  visual_settings_parameter: "div[class*='settings-tab-holder'][data-tabname='Parameters']",
  visual_settings_parameter_data_scope:
    "#viz-settings-tab div[data-setting-id='visual_dataset_scope'] button.dropdown-toggle",
  visual_settings_parameter_explicit_scope: "#viz-settings-tab input[name='explicit_scope']",
  visual_settings_parameter_aggregate: "#viz-settings-tab input[name='SEND_AGGREGATES']",
  visual_settings_data: "div[class*='settings-tab-holder'][data-tabname='Data']",
  visual_settings_downloading: "input[name='DOWNLOAD_ROWS']",
  field_properties_expression_link:
    "[data-test-id='tab-panel-content'] [data-test-id='expression-link']",
  field_properties_display_format_link: "div[class='tab-panel-content'] a.display-format-link",
  edit_expression_container: "[data-test-id='edit-expression-textbox']",
  alert_dialog: "[data-test-id='alert-dialog']",
  xAxis_field_name: ".dash-viz-wrapper text[text-anchor='middle']",
  yAxis_field_name: ".dash-viz-wrapper text[text-anchor='start']",
  radial_legend_name: "g[class~='small-legend'] text.arc-legend-label",
  secondary_field: ".dash-viz-wrapper text[text-anchor='end']",
  refresh_dashboard: '#main > div.viz-params-control > span.viz-params-btn.viz-params-refresh',
  side_panel: 'body > div.builder-container.edit-mode > div.side-tabs-panel.is-open',
  first_visual: '#app-selected-list ul li.gs-w:nth-child(1)',
  second_visual: '#app-selected-list ul li.gs-w:nth-child(2)',
  display_format_type: "select[name='display-format-type']",
  decimal_places: "input[name='display-format-decimal']",
  comma_separator: '#display-format-comma input',
  display_format_save_button: "#display-format-form button[class='btn btn-primary']",
  kpi_value: "li[id *= 'uri-index']  span.kpi-main-value",

  help_dropdown_toggle: "[data-test-id='navbar-help-dropdown-toggle']",
  user_dropdown_toggle: "[data-test-id='navbar-user-dropdown-toggle']",
  logout_button: "[data-test-id='logout']",

  site_admin_menus: {
    set_home_page: "[data-test-id='navbar-settings-menu-set-home-page']",
    job_status: "[data-test-id='navbar-settings-menu-job-status']",
    activity_log: "[data-test-id='navbar-settings-menu-activity-log']",
    site_admin_dropdown_toggle: "[data-test-id='navbar-settings-dropdown-toggle']",
    manage_roles_site_admin: "[data-test-id='navbar-settings-menu-manage-roles']",
    manage_url_aliases: "[data-test-id='navbar-settings-menu-manage-url-aliases']",
    manage_user_and_group_site_admin: "[data-test-id='navbar-settings-menu-users-and-groups']",
    manage_api_keys: "[data-test-id='navbar-settings-menu-manage-api-keys']",
    email_templates_site_admin: "[data-test-id='navbar-settings-menu-email-templates']",
    site_settings_site_admin: "[data-test-id='navbar-settings-menu-site-setting']",
    save_settings_confirm_modal: '#save-settings-confirm-modal',
    manage_custom_colors: "[data-test-id='navbar-settings-menu-custom-colors']",
    manage_custom_dates: "[data-test-id='navbar-settings-menu-custom-dates']",
    manage_custom_styles: "[data-test-id='navbar-settings-menu-custom-styles']",
    static_assets: "[data-test-id='navbar-settings-menu-static-assets']",
  },

  site_enable_extracts_checkbox: "[data-test-id='checkbox-site_enable_extracts']",
  site_settings_save_btn: "[data-test-id='site_settings_save_btn']",
  site_save_btn: '#site-save-btn',

  visual_title_Check: ".arc-viz-title-container > span[id*='title']",
  visual_extension_verify: "div[class^='arc-viz-container'][class$='arc-viz-type-extension']",
  visual_map_verify: "div[class^='arc-viz-container'][class$='arc-viz-type-map']",
  welcome_screen: {
    first_name: 'input#firstname',
    last_name: 'input#lastname',
    email: 'input#emailaddress',
    organization: 'input#organization',
    role: 'input#role',
    eula_checkbox: 'div.form-group > div.checkbox',
    register_button: 'button#registration-btn',
    gotit_button: "[data-test-id='arc-gotit-btn']:visible",
  },
  groups: {
    groups_table_row: '#groups-table > tbody > tr',
    delete_bin: '.fa.fa-trash',
    confirm_delete_button: 'button#delete-group-yes',
  },
  users: {
    new_user_button: "a[href='#new-user-modal'",
    new_group_button: "a[href='#new-group-modal'",
    users_table_row: '#users-table > tbody > tr',
    edit_user_pencil: '.fa.fa-pencil',
    delete_bin: '.fa.fa-trash',
    confirm_delete_button: 'button#delete-user-yes',
    username_textbox:
      '#new-user-form > div.modal-body.ui-draggable-handle > div:nth-child(1) > input',
    password_textbox:
      '#new-user-form > div.modal-body.ui-draggable-handle > div:nth-child(2) > input',
    save_user_button: 'button#save-new-user-btn',
    cancel_user_button: '#new-user-form > div.modal-footer > button.btn.btn-secondary',
  },
  roles: {
    roles_breadcrumbs: 'a[href="/arc/apps/roles"]',
    new_role_button: 'button[data-test-id="newRole"]',
    edit_role_pencil: 'button[data-test-id="editRole"]',
    delete_role_bin: 'button[data-test-id="deleteRole"]',
    confirm_delete_button: 'button[data-test-id="delete-confirmation-yes"]',
    role_row: 'table[data-test-id="manageRolesPage"]>tbody>tr',

    role_details_page: {
      name_field: 'input[data-test-id="role-name-input"]',
      description: 'textarea[data-test-id="role-desc-input"]',
      tabs: {
        members_tab: 'div[data-test-id="members-view"]',
        privileges_tab: 'div[data-test-id="privilege-view"]',
      },
      side_navigation: {
        system: 'div[data-test-id="system_tab"]',
        roles: 'div[data-test-id="roles_tab"]',
        connections: 'div[data-test-id="connections_tab"]',
        datasets: 'div[data-test-id="datasets_tab"]',
      },
      members: {
        edit_users: 'button[data-test-id="role-edit-users"]',
        available_to_select:
          'div[data-test-id="role-user-selection"] div[data-test-id="selection-boxes"] div[data-test-id="available-selection-box"]',
        selected_to_select:
          'div[data-test-id="role-user-selection"] div[data-test-id="selection-boxes"] div[data-test-id="selected-selection-box"]',
        add_selection:
          'div[data-test-id="role-user-selection"] div[data-test-id="selection-boxes"] button[data-test-id="add-selection"]',
        remove_selection:
          'div[data-test-id="role-user-selection"] div[data-test-id="selection-boxes"] button[data-test-id="remove-selection"]',
        apply_button:
          'div[data-test-id="role-user-form"] div.modal-footer > button[data-test-id="apply-btn"]',
        users_table: 'table[data-test-id="roleUsersTable"]',
      },
      privileges: {
        role_privilege_table: 'div[data-test-id="role-priv-table"]',
        add_privilege_button: 'button[data-test-id="add-privilege-btn"]',
        add_privilege_modal: {
          role_modal: 'div[data-test-id="add-roles-privilege-modal"]',
          connection_modal: 'div[data-test-id="add-connections-privilege-modal"]',
          dataset_modal: 'div[data-test-id="add-datasets-privilege-modal"]',
          modal_select_and_list: {
            role_select: 'div[data-test-id="roles"] .form-select__control',
            role_select_list: 'div[data-test-id="roles"] .form-select__menu',

            connection_select: 'div[data-test-id="dataconnections"] .form-select__control',
            connection_select_list: 'div[data-test-id="dataconnections"] .form-select__menu',

            dataset_connection_select:
              'div[data-test-id="dataconnection-for-dataset"] .form-select__control',
            dataset_connection_select_list:
              'div[data-test-id="dataconnection-for-dataset"] .form-select__menu',
            dataset_dataset_select:
              'div[data-test-id="filtered-datasets-by-dataconn"] .form-select__control',
            dataset_dataset_select_list:
              'div[data-test-id="filtered-datasets-by-dataconn"] .form-select__menu',
          },
          containers: {
            system_container: 'table[data-test-id="system-privilege-container"]',
            roles_container: 'table[data-test-id="role-privilege-container"]',
            connections_container: 'table[data-test-id="connection-privilege-container"]',
            datasets_container: 'table[data-test-id="dataset-privilege-container"]',
          },
          permissions: {
            system_permissions: {
              selectAll:
                'table[data-test-id="system-privilege-container"] tbody tr td:nth-child(2) input[data-test-id="test-selectAll"]',
              sys_editperm:
                'table[data-test-id="system-privilege-container"] tbody tr td:nth-child(2) input[data-test-id="test-sys_editperm"]',
              sys_settings:
                'table[data-test-id="system-privilege-container"] tbody tr td:nth-child(2) input[data-test-id="test-sys_settings"]',
              sys_styles:
                'table[data-test-id="system-privilege-container"] tbody tr td:nth-child(2) input[data-test-id="test-sys_styles"]',
              sys_viewlogs:
                'table[data-test-id="system-privilege-container"] tbody tr td:nth-child(2) input[data-test-id="test-sys_viewlogs"]',
              sys_schedules:
                'table[data-test-id="system-privilege-container"] tbody tr td:nth-child(2) input[data-test-id="test-sys_schedules"]',
              sys_editconn:
                'table[data-test-id="system-privilege-container"] tbody tr td:nth-child(2) input[data-test-id="test-sys_editconn"]',
              sys_workspace:
                'table[data-test-id="system-privilege-container"] tbody tr td:nth-child(2) input[data-test-id="test-sys_workspace"]',
              sys_viewroles:
                'table[data-test-id="system-privilege-container"] tbody tr td:nth-child(2) input[data-test-id="test-sys_viewroles"]',
              sys_misc:
                'table[data-test-id="system-privilege-container"] tbody tr td:nth-child(2) input[data-test-id="test-sys_misc"]',
            },
            roles_permissions: {
              header: 'table[data-test-id="role-privilege-container"] tbody tr td:nth-child(1)',
              selectAll:
                'table[data-test-id="role-privilege-container"] tbody tr td:nth-child(2) input[data-test-id="selectAll"]',
              rgds_manage:
                'table[data-test-id="role-privilege-container"] tbody tr td:nth-child(3) input[data-test-id="rgds_manage"]',
              rgds_appedit:
                'table[data-test-id="role-privilege-container"] tbody tr td:nth-child(4) input[data-test-id="rgds_appedit"]',
              rgds_appview:
                'table[data-test-id="role-privilege-container"] tbody tr td:nth-child(5) input[data-test-id="rgds_appview"]',
            },
            connection_permissions: {
              header:
                'table[data-test-id="connection-privilege-container"] tbody tr td:nth-child(1)',
              selectAll:
                'table[data-test-id="connection-privilege-container"] tbody tr td:nth-child(2) input[data-test-id="selectAll"]',
              dc_aviews:
                'table[data-test-id="connection-privilege-container"] tbody tr td:nth-child(3) input[data-test-id="dc_aviews"]',
              dc_upload:
                'table[data-test-id="connection-privilege-container"] tbody tr td:nth-child(4) input[data-test-id="dc_upload"]',
              dc_explore:
                'table[data-test-id="connection-privilege-container"] tbody tr td:nth-child(5) input[data-test-id="dc_explore"]',
            },
            datasets_permissions: {
              header: 'table[data-test-id="dataset-privilege-container"] tbody tr td:nth-child(1)',
              selectAll:
                'table[data-test-id="dataset-privilege-container"] tbody tr td:nth-child(2) input[data-test-id="selectAll"]',
              ds_manage:
                'table[data-test-id="dataset-privilege-container"] tbody tr td:nth-child(3) input[data-test-id="ds_manage"]',
              ds_appedit:
                'table[data-test-id="dataset-privilege-container"] tbody tr td:nth-child(4) input[data-test-id="ds_appedit"]',
              ds_appview:
                'table[data-test-id="dataset-privilege-container"] tbody tr td:nth-child(5) input[data-test-id="ds_appview"]',
            },
          },
          modal_save_button: {
            roles_save:
              'div[data-test-id="add-roles-privilege-modal"] .modal-footer .btn.btn-primary',
            connections_save:
              'div[data-test-id="add-connections-privilege-modal"] .modal-footer .btn.btn-primary',
            datasets_save:
              'div[data-test-id="add-datasets-privilege-modal"] .modal-footer .btn.btn-primary',
          },
          cancel_button:
            '#privilege-modal > div > div > div.modal-footer > button.btn.btn-secondary',
        },
      },
      save_role_button: 'button[data-test-id="save-role-btn"]',
    },
    delete_privilege_button: '.fa.fa-trash.role-perms-trash',
  },
  email_templates: {
    new_template_button: "a[href='customemails/0']",
    template_name: 'input#style-name',
    template_description: 'textarea#style-description',
    save_button: '#save-link',
    clone_button: '#clone-link',
    editor_top_toolbar:
      'div.note-editor.note-frame.panel.panel-default div.note-toolbar.panel-heading',
    arcadia_job_parmeters: 'div.note-btn-group.btn-group.note-arcadiaButtons > div > button',
    underline: '.note-icon-underline',
    font_name:
      'div.note-btn-group.btn-group.note-font .note-btn-group.btn-group button.note-btn.btn.btn-default.btn-sm.dropdown-toggle span.note-current-fontname',
    font_drop_down:
      'div.note-btn-group.btn-group.show .note-dropdown-menu.note-check.dropdown-fontname.show',
    email_message:
      'div.note-editor.note-frame.panel.panel-default table > tbody > tr > td > p > messagebody',
    embedded_image:
      'div.note-editor.note-frame.panel.panel-default table > tbody > tr > td > p > arcadiaembed',
    footer_text:
      "div.note-editor.note-frame.panel.panel-default table > tbody > tr > td[style*='font-size:12px;color:#aaa']",
    wrapper_footer_text:
      'div.note-editor.note-frame.panel.panel-default #email-template-table-wrapper > tbody > tr:nth-child(2) > td',
    back_breadcrumb:
      '.settings-tab-body .settings-tab-bottom .breadcrumb a[href$="../customemails"]',
    email_trash: '.fa.fa-trash',
    job_parameters: {
      job_parameters_dropdown_btn:
        'div.note-editor.note-frame.panel.panel-default > div.panel-heading.note-toolbar > div.note-btn-group.btn-group.note-arcadiaButtons > div > button',
      job_parameters_dropdown_panel:
        'div.note-editor.note-frame.panel.panel-default > div.panel-heading.note-toolbar > div.note-btn-group.btn-group.note-arcadiaButtons > div > ul',
      default_button:
        'div.note-editor.note-frame.panel.panel-default > div.panel-heading.note-toolbar > div.note-btn-group.btn-group.note-arcadiaButtons > div > ul > a[title*="Default Message Here"]',
      embedded_snapshot:
        'div.note-editor.note-frame.panel.panel-default > div.panel-heading.note-toolbar > div.note-btn-group.btn-group.note-arcadiaButtons > div > ul > a[title*="EMBEDDED IMAGE"]',
      username_sender:
        'div.note-editor.note-frame.panel.panel-default > div.panel-heading.note-toolbar > div.note-btn-group.btn-group.note-arcadiaButtons > div > ul > a[title*="<<cloudera_user_id>>"]',
      visual_dashboard_id:
        'div.note-editor.note-frame.panel.panel-default > div.panel-heading.note-toolbar > div.note-btn-group.btn-group.note-arcadiaButtons > div > ul > a[title*="<<app_id>>"]',
      visual_dashboard_name:
        'div.note-editor.note-frame.panel.panel-default > div.panel-heading.note-toolbar > div.note-btn-group.btn-group.note-arcadiaButtons > div > ul > a[title*="<<app_name>>"]',
      visual_dashboard_link:
        'div.note-editor.note-frame.panel.panel-default > div.panel-heading.note-toolbar > div.note-btn-group.btn-group.note-arcadiaButtons > div > ul > a[title*="<<app_url>>"]',
      relative_link:
        'div.note-editor.note-frame.panel.panel-default > div.panel-heading.note-toolbar > div.note-btn-group.btn-group.note-arcadiaButtons > div > ul > a[title*="<<relative_url>>"]',
      job_start_time:
        'div.note-editor.note-frame.panel.panel-default > div.panel-heading.note-toolbar > div.note-btn-group.btn-group.note-arcadiaButtons > div > ul > a[title*="<<start_time>>"]',
      page_parameters:
        'div.note-editor.note-frame.panel.panel-default > div.panel-heading.note-toolbar > div.note-btn-group.btn-group.note-arcadiaButtons > div > ul > a[title*="<<params>>"]',
      total_job_run_time:
        'div.note-editor.note-frame.panel.panel-default > div.panel-heading.note-toolbar > div.note-btn-group.btn-group.note-arcadiaButtons > div > ul > a[title*="<<run_time>>"]',
    },
  },
  data: {
    connection_list: 'ul#dataconnections-list > li',
    connection_explorer_tab: "a[href='#tables']",
    datasets_tab: 'a#tab-dataset',
    dataset_table_row: '#datasets-table tbody tr',
    add_data_button: '#import-data-templ',
    choose_csv_button: '#id_datasource_file',
    get_data_button: '#datasource-get-import',
    connection_explorer_table_row: 'table#table-table > tbody > tr',
    database_list: 'div.db-side-nav > ul#databases-list > li',
    new_dataset_inline_button: 'a.table-new-ds-link.dataset-new',
    new_dataset_title:
      "div[id*='dataset-fixed-modal'][style*='display: block;'] input.form-control.dataset-title",
    confirm_dataset_button:
      "div[id*='dataset-fixed-modal'][style*='display: block;'] button.btn.btn-primary.dataset-create-commit",
    cancel_dataset:
      "div[id*='dataset-fixed-modal'][style*='display: block;'] div.modal-footer > button.btn.btn-secondary",
    newconnection_button: '#newconnection-button',
    new_data_connection: {
      connection_type_dropdown: 'div[data-test-id="connectionType"]',
      connection_name_textbox: 'input[data-test-id="connectionName"]',
      file_name_textbox: 'input[data-test-id="basic-file_name-id"]',
      test_button: 'button[data-test-id="dataconnection-validate"]',
      save_button: 'button[data-test-id="dataconnection-create-commit"]',
      hostname_textbox: 'input[data-test-id="basic-hostname-id"]',
      port_textbox: 'input[data-test-id="basic-port-id"]',
      username_textbox: 'input[data-test-id="basic-username-id"]',
      password: 'input[data-test-id="basic-password-id"]',
    },
    new_dataset_button: 'a#dataset-add',
    trash_icon: '.fa-trash-o',
    new_dataset_modal: {
      dataset_title: '[data-test-id="dataset-create-modal"] input#title',
      sourceType_select: '[data-test-id="dataset-create-modal"] #sourceType',
      database_select: '[data-test-id="dataset-create-modal"] #selectedDatabase',
      table_select: '[data-test-id="dataset-create-modal"] #selectedTable',
      create_button: '[data-test-id="dataset-create-modal"]  button[data-test-id="confirm-btn"]',
      cancel_button: '[data-test-id="dataset-create-modal"] button[data-test-id="close-modal"]',
    },
  },
  dataset_detail: {
    sidebar: 'div > div.sidebar > ul > li',
    fields: "a[href='#attributes']",
    edit_field: '#edit-attr-btn',
    attributes: '#attributes',
    save_edit_fields: '#save-attr-btn',
    fields_list: '.table-list-value-edit',
    field_expression_tab: '#expression-tab>a',
    expression_editor: '#expression',
    edit_column_modal: '#edit-column-modal',
    col_edit_validate_spinner: '[data-test-id="column-edit-validate-spinner"]',
    edit_permissions_button: '#edit-dsperm-btn',
    role_permissions_row: '#role-dataset-priv-table > tbody > tr',
    role_permissions_table: '#role-dataset-priv-table > tbody',
    save_permissions_button: '#save-dsperm-btn',
    extracts_tab_nav_btn: "[data-test-id='extracts-tab-nav-btn']",
    create_extract_btn: '#create-extract-btn',
    new_extract_tgt_dc_chosen: '#extract_target_data_chosen',
    new_extract_tgt_dc_chosen_results: '#extract_target_data_chosen .chosen-results',
    new_extract_tgt_db_chosen: '#extract_db_name_chosen',
    new_extract_tgt_db_chosen_results: '#extract_db_name_chosen .chosen-results',
    new_extract_tgt_table_name: "[data-test-id='new-extract-tgt-table-name']",
    new_extract_dims: '#create-extract-dims',
    new_extract_aggs: '#create-extract-aggs',
    new_extract_parts: '#create-extract-parts',
    new_extract_submit: '[data-test-id="submit-extract-confirmation"]',
    extracts_table_container: "[data-test-id='extracts-table-container']",
    extract_table_row: "[data-test-id='extract-table-row']",
    extract_run_now_btn: "[data-test-id='extract-run-now-btn']",
    extract_state: "[data-test-id='extract-state']",
    extract_del_btn: "[data-test-id='extract-del-btn']",
    extract_form_advanced_nav: "[data-test-id='extract-form-advanced-nav']",
    extract_email_success_status: '#email-upon-success',
    extract_email_fail_status: '#email-upon-failure',
    extract_email_subject: '#extract-email-subject',
    cancel_extract_form: '[data-test-id="cancel-extract-form"]',
    extract_col_action_dropdown: '[data-test-id="extract-col-action-dropdown"]',
    extract_col_action_menu: '[data-test-id="extract-col-action-menu"]',
    extract_agg_funcs: '[data-test-id="extract-agg-funcs"]',
    extract_col_label: '[data-test-id="extract-col-label"]',
    extract_col_div: '[data-test-id="extract-col-div"]',
    extract_remove_col: '[data-test-id="extract-remove-col"]',
    extract_duplicate_col: '[data-test-id="extract-duplicate-col"]',
    extract_col_checkbox: '[data-test-id="extract-col-checkbox"]',
    extract_refresh: '[data-test-id="extract-refresh"]',
    edit_extract_confirmation_modal: '[data-test-id="edit-extract-confirmation-modal"]',
    edit_extract_warning:
      '[data-test-id="edit-extract-confirmation-modal"] [data-test-id="edit-extract-warning"]',
    edit_extract_confirm_cancel: '[data-test-id="edit-extract-confirm-cancel"]',
    datasets_loading_spinner: '[data-test-id="datasets-tab-pane"] [data-test-id="loading-spinner"]',
  },
  map_visual_detail: {
    map_visual: '#chart-map',
    change_type_country: "#properties-panel a[data-action='shelf-cast-geo-country']",
    map_verify: "div[class='gridster ready'] div[class$='map']",
  },
  order_topK_list: {
    order_topK: '#properties-panel li.order-functions',
    order_descending: ".has-submenu.order-functions.open a[data-action='shelf-order-desc']",
    order_ascending: ".has-submenu.order-functions.open a[data-action='shelf-order-asc']",
    topk_input: '#properties-panel .shelf-order-top',
    bottomk_input: '#properties-panel .shelf-order-bottom',
  },
  aggregates_list: {
    aggregates: '#properties-panel li.has-submenu:nth-child(1)',
    sum: "#properties-panel .open [data-action='shelf-agg-sum']",
    count: "#properties-panel .open [data-action='shelf-agg-count']",
    approx_distinct_count: "#properties-panel .open [data-action='shelf-agg-ndv']",
    exact_distinct_count: "#properties-panel .open [data-action='shelf-agg-countdistinct']",
    minimum: "#properties-panel .open [data-action='shelf-agg-min']",
    maximum: "#properties-panel .open [data-action='shelf-agg-max']",
    average: "#properties-panel .open [data-action='shelf-agg-avg']",
    approx_median: "#properties-panel .open [data-action='shelf-agg-appx-median']",
    standard_deviation: "#properties-panel .open [data-action='shelf-agg-stddev']",
  },
  dashboard: {
    alert_container: '.alert-container',
    arc_app_container: '.main-app.arc-app-container',
    control_list: '.main-app.arc-app-container ul.control-list',
    viz_params_control: '.main-app.arc-app-container .viz-params-control',
    current_parameters:
      '#main > div.viz-params-control > span.viz-params-btn.viz-params-display > i',
    back_button: '#main > div.viz-params-control > span.viz-params-btn.viz-params-backward > i',
    forward_button: '#main > div.viz-params-control > span.viz-params-btn.viz-params-forward > i',
    reset_button: '#main > div.viz-params-control > span.viz-params-btn.viz-params-refresh > i',
    more_options: '#main > div.viz-params-control > span.viz-params-btn.viz-params-more > a > i',
    current_parameters_tooltip: '#main > div.viz-params-control > div',
    title: 'div.arc-dashboard-title',
    title_whitespace: 'div.arc-dashboard-title-container',
    visual: {
      title: "div[class='gridster ready']>ul li:nth-child(1) .arc-viz-title-container",
      x_axis:
        "div[class='gridster ready']>ul li:nth-child(1) svg > svg > g.x.arc-viz-axis > g.tick",
      y_axis: "div[class='gridster ready']>ul li:nth-child(1) svg > svg > g.y.arc-viz-axis",
      x_axis_label:
        "div[class='gridster ready']>ul li:nth-child(1) svg > svg > g.x.arc-viz-axis-label",
      y_axis_label:
        "div[class='gridster ready']>ul li:nth-child(1) svg > svg > g.y.arc-viz-axis-label",
      subtitle_container:
        "div[class='gridster ready']>ul li:nth-child(1) div.arc-viz-subtitle-container",
    },
  },
  filters: {
    filter_controller: 'div.selected-control-wrapper',
    filter_container_specific: (index: string | number) =>
      `div.control-container li.selected-control.dropdown:nth-child(${index})`,
    filter_selected_value_specific: (index: string | number) =>
      `div.control-container li.selected-control.dropdown:nth-child(${index}) .selected-count-suffix`,
    filter_dropdown_specific: (index: string | number) =>
      `div.control-container li:nth-child(${index}) .dropdown-toggle`,
    filter_warning_specific: (index: string | number) =>
      `div.control-container li:nth-child(${index}) span.alert-warning`,
    filter_picklist_specific: (index: string | number) =>
      `div.control-container li:nth-child(${index}) div > ul > li`,
    filter_selected_names_specific: (index: string | number) =>
      `div.control-container li:nth-child(${index}) span.selected-names-wrapper > span`,
    filter_selected_count_specific: (index: string | number) =>
      `div.control-container li:nth-child(${index}) span.selected-count-wrapper > span.badge.selected-count`,
    exclude_filter_specific: (index: string | number) =>
      `div.control-container li:nth-child(${index}) div div.picklist-exclude-wrapper input[class='picklist-exclude']`,
    filter_title_specific: (index: string | number) =>
      `div.control-container li:nth-child(${index}) span.base_field`,
    configure_filter_specific: (index: string | number) =>
      `div.control-container li:nth-child(${index}) span > a.configure-app`,
    remove_filter_specific: (index: string | number) =>
      `div.control-container li:nth-child(${index}) span > a.close-app`,
    filter_container: 'div.control-container li.selected-control.dropdown:nth-child(1)',
    filter_dropdown: 'div.control-container li:nth-child(1) .dropdown-toggle',
    filter_select_dropdown:
      'div.selected-control-wrapper > div.chosen-container.chosen-container-single > a > span',
    filter_selectlist: 'div.selected-control-wrapper > select',
    filter_warning: 'div.control-container li:nth-child(1) span.alert-warning',
    filter_picklist: 'div.control-container li:nth-child(1) div > ul > li',
    exclude_filter:
      "div.control-container li:nth-child(1) div div.picklist-exclude-wrapper input[class='picklist-exclude']",
    filter_title: 'div.control-container li:nth-child(1) span.base_field',
    filter_enter_values:
      'div.control-container li.selected-control.dropdown:nth-child(1) div.picklist-upload > a',
    filtervalues_add: '#filter-values-modal button.btn-primary.filtervalues-add',
    filter_values_modal: '#filter-values-modal textarea',
    filter_selected_names:
      'div.control-container li:nth-child(1) span.selected-names-wrapper > span',
    filter_selected_count:
      'div.control-container li:nth-child(1) span.selected-count-wrapper > span.badge.selected-count',
    configure_filter_any: 'div.control-container li:nth-child(index) span > a.configure-app',
    settings_navtab: "a[data-target*='#settings-user-content-']",
    save_settings: '#settings-modal-holder .settings-modal-save',
    cancel_settings:
      "div[id *='settings-modal'][class='settings-modal modal fade in'] button.settings-modal-cancel",
    values: {
      from_base_field:
        "div[data-setting-id='picklist_base_field'] > input[name='PICKLIST_BASE_FIELD']",
      title: "div[data-setting-id='picklist_title'] > input[name='PICKLIST_TITLE']",
      output_parameter:
        "div[data-setting-id='picklist_output_parameter'] > input[name='PICKLIST_OUTPUT_PARAMETER']",
      filter_fields:
        "div[data-setting-id='picklist_filter_columns'] > input[name='PICKLIST_FILTER_COLUMNS']",
      remember_in_viewmode_checkbox:
        "div[data-setting-id='picklist_remember_in_viewmode'] > input[name='PICKLIST_REMEMBER_IN_VIEWMODE']",
    },
    data: {
      sort_order_desc:
        "div[data-setting-id='filter_options_sort_order'] input[data-test-id='radio-DESCENDING']",
      max_rows: "div[data-setting-id='max_rowcount']:nth-child(1) > input[name='MAX_ROWCOUNT']",
      disable_incremental_queries:
        "div[data-setting-id='disable_incremental_queries']:nth-child(2) input[name='DISABLE_INCREMENTAL_QUERIES']",
    },
    display: {
      width: "div[data-setting-id='picklist_width'] > input[name='PICKLIST_WIDTH']",
      textbox_parameter: "div[data-setting-id='picklist_textbox'] input[name='PICKLIST_TEXTBOX']",
      item_count: "div[data-setting-id='picklist_itemcount'] input[name='PICKLIST_ITEMCOUNT']",
      upload_manually: "div[data-setting-id='picklist_upload'] input[name='PICKLIST_UPLOAD']",
      single_select:
        "div[data-setting-id='picklist_single_select'] input[name='PICKLIST_SINGLE_SELECT']",
      all_option:
        "div[data-setting-id='picklist_display_no_selection'] input[name='PICKLIST_DISPLAY_NO_SELECTION']",
      display_dropdown: "div[data-setting-id='picklist_dropdown'] input[name='PICKLIST_DROPDOWN']",
      multi_param: "div[data-setting-id='picklist_multi_parm'] input[name='PICKLIST_MULTI_PARM']",
      hide_empty:
        "div[data-setting-id='picklist_hide_filter_when_empty'] input[name='PICKLIST_HIDE_FILTER_WHEN_EMPTY']",
      remember_selections:
        "div[data-setting-id='remember_selections'] input[name='remember_selections']",
      apply_together:
        "div[data-setting-id='picklist_apply_selections_together'] input[name='PICKLIST_APPLY_SELECTIONS_TOGETHER']",
    },
    visibility: {
      app_visibility: "div[data-setting-id='filter_appgroup_scope'] .form-check:nth-child(3) input",
      sheet_visibility:
        "div[data-setting-id='filter_appgroup_scope'] .form-check:nth-child(2) input",
    },
    scope: {
      all_dataset: "div[data-setting-id='filter_dataset_scope'] .form-check:nth-child(2) input",
      current_dataset: "div[data-setting-id='filter_dataset_scope'] .form-check:nth-child(3) input",
      explicit: "div[data-setting-id='filter_dataset_scope'] .form-check:nth-child(4) input",
    },
    cstyle: {},
  },
  date_filters: {
    filter_container: 'div.control-container li.selected-control.dropdown:nth-child(1)',
    filter_dropdown: 'div.control-container li:nth-child(1) .dropdown-toggle',
    dropdown_menu: 'div.control-container li:nth-child(1) .dropdown-menu.show',
    fixed_date_picker:
      "div.control-container li:nth-child(1) div.show-calendar[style *='display: block;']",
    fixed_datepicker_start: 'div.ranges > div > div.daterangepicker_start_input > input',
    fixed_datepicker_end: 'div.ranges > div > div.daterangepicker_end_input > input',
    fixed_datepicker_apply: 'div.ranges > div > button.btn-primary',
    relative_datepicker: 'div.control-container .relative-date-holder',
    relative_datepicker_anchorto: 'div.form-group.anchor-fixed > div > input',
    relative_datepicker_units: 'div.form-inline.units select.unit-selector',
    relative_datepicker_previous_one: "input[value='previous-one']",
    relative_datepicker_this: "input[value='this'] ",
    relative_datepicker_previous: "input[value='previous'] ",
    relative_datepicker_next: "input[value='next'] ",
    relative_datepicker_ytd: "input[value='to-date'] ",
    relative_datepicker_next_one: "input[value='next-one'] ",
    relative_datepicker_anchorto_text: 'div.form-group.anchor-fixed > span',
    relative_datepicker_apply:
      'div.filter-relative-btns > button.applyBtn.btn.btn-small.btn-sm.btn-primary',
    quickfilters:
      'div.control-container li:nth-child(1)  div > div > div.date-range-input > div.quick-filters',
    filter_select_dropdown:
      'div.selected-control-wrapper > div.chosen-container.chosen-container-single > a > span',
    filter_selectlist: 'div.selected-control-wrapper > select',
    filter_warning: 'div.control-container li:nth-child(1) span.alert-warning',
    filter_picklist: 'div.control-container li:nth-child(1) div > ul > li',
    filter_title: 'div.control-container li:nth-child(1) span.base_field',
    filter_enter_values:
      'div.control-container li.selected-control.dropdown:nth-child(1) div.picklist-upload > a',
    filtervalues_add: '#filter-values-modal button.btn-primary.filtervalues-add',
    filter_values_modal: '#filter-values-modal textarea',
    filter_selected_names:
      'div.control-container li:nth-child(1) span.selected-names-wrapper > span',
    filter_selected_count:
      'div.control-container li:nth-child(1) span.selected-count-wrapper > span.badge.selected-count',
    configure_filter: 'div.control-container li:nth-child(1) span > a.configure-app',
    settings_navtab: "a[data-target*='#settings-user-content-']",
    save_settings: '#settings-modal-holder .settings-modal-save',
    basic: {
      timerange_cb: "div[data-setting-id='show_time'] input[name='SHOW_TIME']",
      base_field: "div[data-setting-id='daterange_base_field'] > input[name='PICKLIST_BASE_FIELD']",
      title: "div[data-setting-id='daterange_title'] > input[name='PICKLIST_TITLE']",
      output_parameter:
        "div[data-setting-id='daterange_output_parameter'] > input[name='PICKLIST_OUTPUT_PARAMETER']",
    },
    data: {
      max_rows: "div[data-setting-id='max_rowcount']:nth-child(1) > input[name='MAX_ROWCOUNT']",
      disable_incremental_queries:
        "div[data-setting-id='disable_incremental_queries']:nth-child(2) input[name='DISABLE_INCREMENTAL_QUERIES']",
    },
    style: {
      width: "div[data-setting-id='daterange_width'] > input[name='DATERANGE_WIDTH']",
    },
    visibility: {
      app_visibility:
        "div[data-setting-id='filter_appgroup_scope'] .radio-inline:nth-child(3) input",
      sheet_visibility:
        "div[data-setting-id='filter_appgroup_scope'] .radio-inline:nth-child(2) input",
    },
    scope: {
      alldashboards_visible:
        "div[data-setting-id='filter_appgroup_scope'] input[name='FILTER_APPGROUP_SCOPE']",
      all_dataset: "div[data-setting-id='filter_dataset_scope'] .radio:nth-child(2) input",
      current_dataset: "div[data-setting-id='filter_dataset_scope'] .radio:nth-child(3) input",
      explicit: "div[data-setting-id='filter_dataset_scope'] .radio:nth-child(4) input",
    },
    cstyle: {},
  },
  Search_Dashboard_Visuals_Page: '[data-test-id="searchbox"]',
  listview_Visualspage: "[data-test-id='list-view']",
  gridview_Visualspage: "[data-test-id='grid-view']",
  Visuals_all: "[data-test-id='app-group-all']",
  allTypeButton: "[data-test-id='app-grid-all-btn']",
  renameSheet: {
    sheet: '.sheet-handle',
    menuIcon: '.caret',
    menuRename: '.sheet-rename',
    name: '.sheet-title',
    menuClone: '.sheet-clone',
    menuDelete: '.sheet-delete',
  },
  visualEdit: {
    visual: '#app-selected-list>ul>li',
    ellipsis: "[data-test-id='visual-list-item']:nth-child(1) [data-test-id='visual-more']",
    ellipsis_index:
      "[data-test-id='visual-list-item']:nth-child(index) [data-test-id='visual-more']",
    linkUnlink: '.viz-contextmenu .link-visual-toggle',
    styleSettings: '#style',
    linkUnlinkConfirm: '#confirm-link-unlink-modal button.confirm-button',
    overrideWarning: '.super-modal.edit-mode .modal-button-bar #override-warning',
    Visuals_all: ".app-menu-perm a[data-appgroup='-1'] .app-group:nth-child(2)",
    visual_filter_shelf: 'div.shelves-wrapper div.selected-list-wrapper ul#filters_shelf',
    removeButtonOnShelfItem: (shelfId: string, itemName: string) =>
      `#${shelfId} li[data-test-id='${shelfId}-app-shelf-item']:contains(${itemName}) .field-remove`,
    sidePanels: {
      settingPanel: '.dash-settings-panel',
      settingPanelCloseButton: ".dash-settings-panel i[class*='settings-close']",
    },
    moreOptions: {
      submenu: '[data-test-id="visual-submenu"]',
      options: {
        saveAsTableOrDataset: 'li a:contains("Save as Table or Dataset")',
      },
    },
    newtable_from_visual: {
      modal: '[data-test-id="create-newtable"]',
      dbname: '[data-test-id="newtable-dbname"]',
      loading_spinner: '[data-test-id="create-newtable-loading-spinner"]',
    },
  },
  filterTab: {
    filter: '#dash-filters-tab > ul.dim-app-params li.selection_element:nth-child(2)',
  },
  selectedControl: {
    icon: '.control-container ul.control-list.ui-sortable .widget-btns-wrapper',
    settingIcon: "[data-tooltip-contents='Configure filter']",
    filterName: "[name='PICKLIST_TITLE']",
    save: '#settings-modal-holder .settings-modal-save',
  },
  workspace: {
    dashboards: '.object-container .dashboard',
    createWorkspaceIcon: '.ws-list-edit',
    wsEditModal: '#workspace-edit-modal',
    wsName: "[data-test-id='workspace-name-input']",
    wsNameSave: '[data-test-id="save-workspace-button"]',
  },
  dashboardDetail: {
    menu: '#report-menu-list',
    workspaceMenu: 'li.move-viz-btn a.more-btn',
    workspaceMove: '.save-workspace-move:visible',
    workspaceMoveCloneModel: '.clone-move-with-linked-modal',
    workspaceMoveMoveVisualRadio: '.move-option',
    workspaceMoveCloneVisualRadio: '#partialCloneVisual',
    workspaceMoveMaintainVisualRadio: '#partialMaintainLink',
    workspaceMoveMoveNow: '.btn-submit-clone-move',
    visualName: '.move-table-visual-name',
    infotooltip: ".affected-dashboards i '[data-toggle]",
    dashboardContainer: '.gridster-container',
    FilterName:
      ".control-container [class='control-list ui-sortable'] li:first-child span.base_field",
    linkVisualIcon: '.arc-viz-container .linked-visual-icon',
  },
  addSheetMenu: {
    menuIcon: '#add-dash-sheet .dropup.sheet-caret',
    importSheet: '.import-sheet',
    addSheet: '.add-new-sheet',
    moresheet: '.more-btn',
  },
  reportPickModal: {
    modal: '.report-pick-modal',
    searchBox: '#searchbox',
    sheetList: '.app-avail-list',
  },
  navigateToDashboardModal: {
    navToDashPassParams: "#target-nav-selector [type = 'checkbox']",
    searchbox: 'div.form-group #searchbox',
  },
  barVisual: {
    x_Axis: '#x_shelf',
    y_Axis: '#y_shelf',
    barVerify: "div[class='gridster ready'] div[class$='bars']",
  },
  Extension_Visual_Details: {
    extension_visual: '#chart-extension',
    html_textarea: '#app-shelves .raw-editor',
  },
  visual_radial_verify: "div[class^='arc-viz-container'][class$='arc-viz-type-radial']",
  visual_bar_verify: "div[class^='arc-viz-container'][class$='arc-viz-type-trellis-bars']",
  apps: {
    modifyAppMenu: '.app-menu-edit',
    modifyAppModal: '#edit-app-menu-modal',
    newGroupLink: '.new-group-link',
    groupListWraper: '.group-list-wrapper',
    newGroupDelete: '.new-group-delete',
    appSave: '#edit-app-menu-save',
    AddtoApp: '#add-to-group-btn',
    app_name_selector: '.app-group',
    app_bubble: '.badge',
    dashboardTitle: '#dashboard-title',
    favourites_tab: '[data-test-id="favorites-app-group"]',
    editapp: '#edit-link',
    deletegroup_btn: '#delete-appgroup',
    delete_textbox: '#delete-confirmation-text',
    deleteconf_button: '#delete-confirmation-yes',
    dashboardcheckbox: "#report-table tbody tr [type='checkbox']",
    editappsettings_icon: '.edit-appgroup.settings-icon',
    applist_btn: '#app-list-btn1',
    delete_pop_up: '#delete-confirmation-modal',
  },
  workspace_regression: {
    Gotit_button: "[data-test-id='arc-gotit-btn']",
    WhatsNew_popup: '.new-release-modal',
    Deletedashboardconfirm: '#delete-dashboard-yes',
    Dashboard_edit_ellipsis: '#report-menu-list .fa-ellipsis-h',
    Dashboard_clone: "#report-menu-list [data-test-id='clone-link']",
    Public_workspace: ".ws-menu-list span[title='Public']",
    Workspace_move: '.popover-btns .save-workspace-move',
    Applist_btn: '#app-list-btn2',
    workspace_menulist: '.ws-menu-list',
    Deletedashboard_option: '.delete-db-link',
    Dashboardedit_dropdown: 'ul.dropdown-menu',
    public_gear_icon: ".ws-menu-list span[class='edit-workspace edit-icon ']",
    username_textbox: "input[placeholder='type username'][class='token-input tt-input']",
    view_permission: "input[value='VIEW']",
    manage_permission: "input[value='MANAGE']",
    edit_permission: "input[value='EDIT']",
    save_permission_btn: "button[class*='ws-save-button']",
    gear_icon_invisible: 'edit-workspace settings-icon arc-invisible',
    WSEditModal: '#workspace-edit-modal',
    wsname: "[data-test-id='workspace-name-input']",
    wsdesc: "[data-test-id='workspace-desc-input']",
    wsdeletebtn: '[data-test-id="delete-workspace-button"]',
    gearmodalclose: '.close',
    wspermissions_remove: '.ws-remove-item',
    gear_icon: ".ws-menu-list span[title='Public'] + span",
  },
  login: {
    username: '#username',
    password: '#password',
  },
  changePassword: {
    form: '#change-password-form:visible',
    password: '#password',
    newPassword: '#newPassword',
    confirmPassword: '#confirmPassword',
    submitButton: '#change-password-submit-button',
  },
} as const;

export type CSSselectorType = typeof CSSselector;
