import { logins } from 'lib/arctest';
import * as dashboards from 'lib/dashboard';
import { combinatedBarLineDashboard } from 'lib/dashboard/default_dashboard';
import * as visuals from 'lib/visual';

describe('Arcviz Combined Bar Line visuals.', () => {
  context('ARC-9906', () => {
    before(() => {
      logins.silent();
    });

    it('Test 1: Test Secondary Axis', () => {
      dashboards.createDashboard(combinatedBarLineDashboard);
      visuals.verifyVisual(combinatedBarLineDashboard);
    });
  });
});
