import { logins } from 'lib/arctest';
import * as dashboards from 'lib/dashboard';
import * as visual from 'lib/visual';

import { dashboardWithLineVisual } from '../../../../lib/dashboard/default_dashboard';

describe('Arcviz Line visuals tests.', () => {
  before(() => {
    logins.silent();
    cy.visit('/arc/apps/home');
  });

  context('Line visual tests', () => {
    it('Test 1: Create line graph visual', () => {
      dashboards.createDashboard(dashboardWithLineVisual);
      visual.verifyVisual(dashboardWithLineVisual);
    });
  });
});
