#!/bin/bash
#
# docker-arcviz-address.sh
# This script will output the address of the arcviz container
#
#

scriptdir="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"
dockerdir="${scriptdir}/../docker"

# must run docker-compose from the docker directory
cd ${dockerdir}

ARCVIZADDR=$(docker-compose port arcviz 38888) && echo "http://${ARCVIZADDR}" | sed  s/0.0.0.0/127.0.0.1/g