#!/bin/bash
#
# docker-wait-on-arcviz.sh
# This script will wait for the arcviz container to become available
#
#

scriptdir="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"


until ARCVIZADDR=$(docker-compose port arcviz 38888)
do
  sleep 5
done
ARCVIZADDR=$(echo "http://${ARCVIZADDR}" | sed  s/0.0.0.0/127.0.0.1/g)
cd ${scriptdir}/..


until $(wget --tries=120 ${ARCVIZADDR}/arc/apps/login -O /dev/null); do     
    printf '.';     
    sleep 5; 
done