import { email_settings, advanced_settings } from './common';

const extra_advanced_settings = [
  `RAWSQL_WHITELIST='*'`,
];
/**
 * Invoked by viz-qe to insert values into the VIZ metadata store.
 * @returns string key-value pairs that re to be inserted into reports_appsetting
 */
export function getConfig(): { [key: string]: string } {
  return {
    ...email_settings(),
    advanced_settings: advanced_settings()
      .concat(extra_advanced_settings)
      .join('\n'),
  };
}
