// webpack.config.js
module.exports = {
  resolve: {
    extensions: ['.ts', '.js'],
    modules: [
      "node_modules",
      "cypress/lib",
      "cypress"
    ]
  },
  module: {
    rules: [
      {
        test: /\.ts$/,
        exclude: [/node_modules/],
        use: [{
          loader: 'ts-loader',
          options: {
            transpileOnly: true // IMPORTANT! use transpileOnly mode to speed-up compilation
          }
        }],
      },
    ],
  },
}