# [Jira](https://jira.cloudera.com/browse/VIZ-)

## [Viz PR (if needed)](https://github.infra.cloudera.com/Sense/viz/pull/)

## [Quanta, single run](https://quanta.infra.cloudera.com/#/runDetails?gtn=)

## [Quanta, nightly](https://quanta.infra.cloudera.com/#/runDetails?gtn=)

## Changed 💡

Describe the changes that were made. What is their purpose?

## Safety checks ✅

- [ ] I have performed a self-review of my code
- [ ] I have added the new e2e test file(s) (in case new test file(s) was/were created) to the applicable suite-1.txt or suite-2.txt
- [ ] I have a green quanta run for the affected test files
- [ ] I have considered a nightly run (and have a green quanta)
- [ ] I have added labels, project, links and milestone as applicable
- [ ] _Once ready to merge:_ Make sure that the test PR is still compatible with the latest changes, merge and change the Jira status to resolved

### Notes for the reviewer

- Make sure that there's a green quanta for the test
- If the change is not minor, or it is in an older test file, make sure that there's a nightly run as well
- If a new test file was created, make sure that it's added to one of the test suits
- Consider cypress guidelines: in most cases, test should be relatively isolated and they should run successfully on their own
