export let locators = {
  setHomepageTitle: 'h3[data-test-id="pageHeader"]',
  adminOnlyTitle: 'h4[data-test-id="adminHeader"]',
  dashboardName: 'form[data-test-id="user-setHomepageForm"] .form-select__single-value',
  dashboardID:
    'form[data-test-id="user-setHomepageForm"] .select-container > input[name="dashboardSelect"]',
  dashboardSave: 'form[data-test-id="user-setHomepageForm"] button[data-test-id="setHomepageSave"]',
  reset_admin_defined_homepage:
    'form[data-test-id="user-setHomepageForm"] button[data-test-id="setHomepageReset"]',
  adminOnlyDashboardID:
    'form[data-test-id="admin-setHomepageForm"] .select-container > input[name="dashboardSelect"]',
  adminOnlyResetHomepage:
    'form[data-test-id="admin-setHomepageForm"] button[data-test-id="setHomepageReset"]',
  adminOnlyDashboardName: 'form[data-test-id="admin-setHomepageForm"] .form-select__single-value',
  adminOnlyDashboardSave:
    'form[data-test-id="admin-setHomepageForm"] button[data-test-id="setHomepageSave"]',
  adminOnlyDisableOverrideCheckbox:
    'form[data-test-id="admin-setHomepageForm"] input[data-test-id="setHomepageDisable"]',
  adminOnlyDisableOverrideConfirmButton:
    'div[data-test-id="overrideModal"] .modal-footer button[data-test-id="confirmOverride"]',
  userSelectControl: 'form[data-test-id="user-setHomepageForm"] .form-select__control',
  dashboards: '[data-test-id="overview-dashboards"]',
  dashboards_number: '[data-test-id="overview-dashboards"] div div:nth-child(1)',
  apps: '[data-test-id="overview-apps"]',
  apps_number: '[data-test-id="overview-apps"] div div:nth-child(1)',
  datasets: '[data-test-id="overview-datasets"]',
  datasets_number: '[data-test-id="overview-datasets"] div div:nth-child(1)',
  total_views: '[data-test-id="overview-total-views"] div div:nth-child(1)',
  dashboard_created_text: 'h5:contains("Over the last 7 days") ~ span:nth-of-type(1)',
  apps_created_text: 'h5:contains("Over the last 7 days") ~ span:nth-of-type(2)',
  datasets_created_text: 'h5:contains("Over the last 7 days") ~ span:nth-of-type(3)',
  learn: 'div:contains("LEARN") ~ a',
  last_login: 'span:contains("Your last login was on:")',
  app_panel: '.app-builder-container',
  list_view: '[data-test-id="list-view"]',
  tableinfo_visual: '[data-test-id="table-row-max-row-count"]',
  connection_list: '#dataconnections-list > li',
  connection_count: '#datasets-count',
};
