/*
 * Functions that let you login into known systems
 */

import * as arctest from 'lib/arctest';

/**
 * log into larry on a specific port from the UI
 *
 * @export
 * @param {string} port
 */
export function larry(port: string) {
  if (!port) {
    port = '';
  }

  const baseUrl = `https://cypress:cypressAutoPass!!23@sj.arcadiadata.com:${port}`;
  arctest.logins.defaultShow(baseUrl);
}
