// users and groups related locators
export let locators = {
  users_tab: "a[href='#users-tab']",
  group_tab: "a[href='#groups-tab']",
  users: {
    username: 'div#new-user-modal input.user-username',
    password: 'div#new-user-modal input.password-input',
    name: '.user-table-name',
    inactive: "input[value='inactive']",
    save: 'button#save-edit-user-btn.btn.btn-primary',
    cancel: '#edit-user-modal button[data-action="cancel"]',
    last_login: '#edit-user-modal div.detail-info > div:nth-child(2) > div.user-lastlogin',
    delete: '#edit-delete-user-btn',
  },
  roles: {
    role: 'a[href="#user-roles-tab-new"]',
    available_roles: 'div#user-roles-tab-new ul.selection-list.not-selected',
    add: 'div#user-roles-tab-new a.add-selection',
  },
  groups: {
    easy_grp_add: "#new-user-modal div[class='arc-easy-add active-wrapper']",
    name: '.group-table-name.sorting_1 span',
    roles_tab: 'a[href="#group-roles-tab-new"]',
    available_roles: 'div#group-roles-tab-new ul.selection-list.not-selected',
    add: 'div#group-roles-tab-new a.add-selection',
    table_rows: 'div#groups-tab',
    group_name: 'div#new-group-modal input.group-name',
    users: 'div#users-tab-new ul.selection-list.not-selected',
    add_user: '#users-tab-new a.add-selection',
    save: '#save-new-group-btn',
    table_data: '#groups-table >tbody > tr',
    edit: {
      roles_tab: 'a[href="#group-roles-tab-edit"]',
      add: 'div#group-roles-tab-edit a.add-selection',
      available_roles: 'div#group-roles-tab-edit ul.selection-list.not-selected',
      save: '#save-edit-group-btn',
    },
  },
};
