// Workspace Related Locators

export let locators = {
  dataset_page_header: '#detail h3.data-section-header',
  home_stats: 'div.home-right-side ul',
  dashboard_radio_btn: '[data-test-id="app-grid-dashboards-btn"]',
  app_radio_btn: '[data-test-id="filter-for-apps-button"]',
  all_private_ws: '[data-test-id="toggle-private-workspaces"]',
  private_ws_list: 'ul.app-menu.ws-private-menu-list > li',
  grid_dashboard_list: '[data-test-id"grid-item-link"]',
  create_workspace: '[data-test-id="create-workspace-icon"]',
  move_to_ws_button: '[data-test-id="move-workspace"]',
  cancel_workspace_move: 'div.popover .popover-btns .cancel-workspace-move',
  save_workspace_move: '[data-test-id="submit-move-workspace"]',
  selected_ws_on_import: "select[name='workspace_id'] option[selected='selected']",
  planned_action: 'tr[export-tag="dashboards"] td:nth-child(3)',
  user_defined_ws: ".ws-menu-list [title='wsTitle']",
  visual_clone: '#report-menu-list .dropdown > ul > li > a.clone-link',
  clone_move: '.btn-submit-clone-move',
  single_viz_app_title: "div.viz-permanent div[class='arc-viz-title-container'] > span",
};
