import { logins } from 'lib/arctest';
import * as utils from './email_template/util';

describe('Arcviz end to end UI test', () => {
  before(() => {
    logins.silent();
  });

  // skipping update of Kiwi TCMS after each function

  // Function to get unique time to be used in Db/sheet name

  describe('Email template test', () => {
    /*
     Create an email temp
     try to use most of the html editor options
    */
    describe('As user "admin", he should be able to create and save an email template using the html template editor', () => {
      describe('create email template', () => {
        // just need to email template name and desription and
        // emailData object which can be parsed to conditionally create different types of emails
        // since we allow exact same template names and descriptions and email editor (this is BUG imho - should be like role - no duplicates)
        it('should let the user create a new email template', () => {
          cy.visit('/');
          cy.fixture('emails.json').then((data) => {
            utils.addEmailTemplate(data.template);
          });
        });

        // it('should let the user create a privilege', () => {
        //   cy.fixture('dataset_publishing.json').then(function (data) {
        //     cy.addPrivilege(data.privilege[0])
        //   })
        // })
      });
      // can search for it now after creating - but i feel there is a bug
    });
  });
});
