import { logins } from 'lib/arctest';
import * as functions from 'lib/functions';
import * as imp_exp from 'lib/import_export';

describe('import tests', () => {
  const visualFile = 'Cereals Visual.json';

  before(() => {
    cy.fixture('users.json').then((data) => {
      logins.silent(data.admin.username, data.admin.password);
    });
  });

  it('Test 1: export sample app', () => {
    functions.navigate_to_visuals();
    imp_exp.export_app('Sample App');
    imp_exp.import_artifacts('samples', visualFile);
  });

  // it('Test 1: import sample app', () => {
  //  functions.navigate_to_data();
  //  imp_exp.import_artifacts('colo');
  // });
});
