import { logins } from 'lib/arctest';
import * as dashboards from 'lib/dashboard';
import * as combo_functions from 'lib/visual/visual_bar_line_combo_area_group';

import { dashboardWithLineVisual } from '../../../../lib/dashboard/default_dashboard';

const datasetName = 'Cereals';

describe('Arcviz Line visuals tests.', { retries: 2 }, () => {
  context('Line visual tests data tab tests', () => {
    before(() => {
      logins.silent();
      dashboards.createDashboard(dashboardWithLineVisual);
    });

    beforeEach(() => {
      dashboards.chooseVisualTab('data');
    });

    it('Test 1: Switch data set', () => {
      combo_functions.switchDataSet(datasetName);
    });
  });
});
