#!/bin/bash
#
# docker-wait-on-cypress.sh
# This script will wait for the cypress container to become available
#
#

scriptdir="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"
dockerdir="${scriptdir}/../docker"

# must run docker-compose from the docker directory
cd ${dockerdir}

until docker-compose exec -T cypress bash -c '(cd /home/cypress; npx cypress verify)' --silent
do
  sleep 30
done


